<!-- markdownlint-disable MD033 MD041 -->
<h1 align="center">
    chatcell
</h1>

<p align="center">
    <strong>A python framework to create your personal AI assistant 🤖.</strong>
</p>

<p align="center">
    <a href="https://pypi.org/project/chatcell/" title="PyPi Version"><img src="https://img.shields.io/pypi/v/chatcell?color=green&style=flat"></a>
    <a href="https://github.com/langelo-ai/chatcell/actions/workflows/release.yml" title="PyPi Version"><img src="https://github.com/langelo-ai/chatcell/actions/workflows/release.yml/badge.svg"></a> 
    <a href="https://pypi.org/project/chatcell/" title="Python Version"><img src="https://img.shields.io/badge/Python-3.10%2B-blue&style=flat"></a>
    <a href="https://github.com/langelo-ai/chatcell/blob/main/LICENSE" title="Project License"><img src="https://img.shields.io/badge/License-Apache2.0-blue.svg"></a>
</p>

<p align="center">
  <a href="#getting-started">Getting Started</a> •
  <a href="#license">License</a> •
  <a href="https://github.com/langelo-ai/chatcell/releases">Changelog</a>
</p>

chatcell is a Python framework that allows you to create a chatbot, which can respond to your commands and perform various tasks according to your requirements. 

---

## ⚡ Highlights

- 💬 Create your personal AI assistant.
- 📈 Customize responses and functions to enhance versatility.
- 🧩 Extentable framework for variety of chat-based tasks.
- 🔗 Integrated with cutting-edge AI stack.
- 🤗 One-click deployment to Hugging Face and Replit.

## 🔧 Installation

- chatcell can be installed using pip with the following command:

    ```
    pip install chatcell
    ```

## 💡 Examples

- Example implementations
  - [Echo Bot](./examples/echobot/), an example bot which return exactly what you send to him.
  - [Cat Bot](./examples/catbot/), this example is intended to cover most of the options that the chatcell provides.
  - [OpenAI Bot](./examples/openaibot/), an example bot built on top of OpenAI Chat Completion API, powered by [openai-python](https://github.com/openai/openai-python).
  - [LangChain Bot](./examples/langchainbot/), an example bot built on top of ChatGPT using [LangChain](https://github.com/hwchase17/langchain).
  - [LlamaIndex Bot](./examples/llamabot/), a knowledge-augmented bot powered by [LlamaIndex](https://gpt-index.readthedocs.io/en/latest/).

## 🌱 Contributing

- Contributions to the chatcell framework are welcome! Please submit any bug reports, feature requests, or pull requests through the [GitHub repository](https://github.com/langelo-ai/chatcell).

## License

- This project is licensed under the Apache-2.0 License.